/* Generated By:JJTree&JavaCC: Do not edit this line. Parser.java */
package org.tautua.markdownpapers.parser;
import org.tautua.markdownpapers.ast.*;


import org.tautua.markdownpapers.ast.*;
import org.tautua.markdownpapers.util.*;

public class Parser/*@bgen(jjtree)*/implements ParserTreeConstants, ParserConstants {/*@bgen(jjtree)*/
  protected JJTParserState jjtree = new JJTParserState();private static final String EMPTY_STRING = "";
    private static final String QUOTE = '"' + "";

    private Stack<Node> stack = new DequeStack<Node>();
    private Stack<Node> markupStack = new DequeStack<Node>();
    private int currentQuoteLevel = 0;
    private int parentheses;
    private int brackets;

    public Document parse() throws ParseException {
        jj_input_stream.setTabSize(4);
        Document();
        return (Document)getRootNode();
    }

    public Node getRootNode() {
        return jjtree.rootNode();
    }

    char getEscapedChar(Token t) {
        return t.image.charAt(1);
    }

    String getValue(Token t) {
        if (t.kind == CODE_SPAN && t.image.startsWith("``")) {
            return getValue(t, 2);
        } else if (t.kind == TEXT) {
            return t.image;
        }
        return getValue(t, 1);
    }

    String getValue(Token t, int markLength) {
        return t.image.substring(markLength, t.image.length() - markLength);
    }

    String getTabWhitespace(Token prev, Token tab) {
        int x = (4 - ((prev == null ? 1 : prev.endColumn + 1) % 4)) + 1;
        switch(x) {
            case 1:
                return " ";
            case 2:
                return "  ";
            case 3:
                return "   ";
            default:
                return "    ";
        }
    }

    boolean ParagraphLookahead() {
        if (getToken(1).kind != EOL) {
            return false;
        }

        int i = 2;
        int quoteLevel = 0;
        Token t;

        do {
            t = getToken(i++);
            if (t.kind == GT) {
                quoteLevel++;
            } else if (t.kind == EOL) {
                quoteLevel = 0;
            }
        } while(t.oneOfKind(EOL, SPACE, TAB, GT));

        if (t.oneOfKind(PLUS, MINUS, ASTERISK, NUMBERING, EOF)) {
            return false;
        }

        if (currentQuoteLevel == quoteLevel && stack.size() > 0 && stack.peek() instanceof Item
            && ((Item)stack.peek()).getIndentation() < t.beginColumn) {
            return true;
        }

        return false;
    }

    boolean LineLookahead() {
        if (getToken(1).kind != EOL) {
            return false;
        }

        int i = 2;
        int quoteLevel = 0;
        Token t;

        do {
            t = getToken(i++);
            if(t.kind == GT) {
                quoteLevel++;
            }
        } while (t.oneOfKind(SPACE, TAB, GT));

        if (t.oneOfKind(EOL, EOF)) {
            return false;
        }

        if (stack.peek() instanceof Item && t.oneOfKind(PLUS, MINUS, ASTERISK, NUMBERING)) {
            return false;
        }

        if (currentQuoteLevel < quoteLevel) {
            return false;
        }

        return true;
    }

    boolean CodeLineLookahead() {
        if (getToken(1).kind != EOL) {
            return false;
        }

        int i = 2;
        int quoteLevel = 0;
        int _indent = 0;
        Token t;

        do {
            t = getToken(i++);
            if(t.kind == GT) {
                quoteLevel++;
                _indent = 0;
            } else if(t.kind == SPACE) {
                _indent++;
            } else if(t.kind == TAB) {
                _indent += 4;
            }
        } while (t.oneOfKind(SPACE, TAB, GT) && _indent < 4);

        if (t.oneOfKind(EOL, EOF)) {
            return true;
        }

        if (currentQuoteLevel >= quoteLevel && _indent >= 4) {
            return true;
        }

        return false;
    }

    boolean QuotedElementLookahead() {
        int level = 0;
        int i = 1;
        Token t = getToken(i);

        if (t.kind != EOL) {
            return false;
        }

        do {
            t = getToken(++i);
            if (t.kind == GT) {
                level++;
            }
        } while (t.oneOfKind(SPACE, TAB, GT));

        if (t.oneOfKind(EOL, EOF)) {
            return true;
        }

        if (currentQuoteLevel <= level) {
            return true;
        }

        return false;
    }

    boolean LooseLookahead() {
        if (getToken(1).kind != EOL) {
            return false;
        }

        int i = 2;
        Token t;
        boolean newline = false;
        do {
            t = getToken(i++);
            if (t.kind == EOL) {
                newline = true;
            }
        } while(t.oneOfKind(SPACE, TAB, EOL));

        Item item = (Item)stack.peek();

        return newline && t.oneOfKind(PLUS, MINUS, ASTERISK, NUMBERING) && item.getIndentation() == t.beginColumn;
    }

    boolean TextLookahead() {
        if (stack.size() > 0 && stack.peek() instanceof Header) {
            int i = 1;
            Token t;
            do {
                t = getToken(i++);
            } while(t.oneOfKind(SHARP));

            return t.noneOfKind(EOL,EOF);
        }

        return getToken(1).noneOfKind(EOL, EOF);
    }

    boolean ListLookahead() {
        if (getToken(1).kind != EOL) {
            return false;
        }

        Item item = (Item)stack.peek();
        Token t;
        int i = 2;
        int quoteLevel = 0;

        do {
            t = getToken(i++);
            if (t.kind == GT) {
                quoteLevel++;
            }
        } while (t.oneOfKind(EOL, SPACE, TAB, GT));

        if (t.oneOfKind(PLUS, MINUS, ASTERISK, NUMBERING)
            && item.getIndentation() < t.beginColumn) {
            return true;
        }

        return false;
    }

    boolean ItemLookahead() {
        if (getToken(1).kind != EOL) {
            return false;
        }

        List list = (List)stack.peek();
        Token t;
        int i = 2;
        int quoteLevel = 0;
        do {
            t = getToken(i++);
            if (t.kind == GT) {
                quoteLevel++;
            }
        } while (t.oneOfKind(EOL, SPACE, TAB, GT));

        if (t.oneOfKind(PLUS, MINUS, ASTERISK, NUMBERING)
            && list.getIndentation() == t.beginColumn) {
            return true;
        }

        return false;
    }

    boolean QuoteInsideTitleLookahead(int quoteKind) {
        if (getToken(1).kind == quoteKind) {
            Token t;
            int i = 2;
            do {
                t = getToken(i++);
            } while (t.noneOfKind(quoteKind, RPARENT, EOL, EOF));

            return t.kind == quoteKind;
        }

        return getToken(1).noneOfKind(EOL, EOF);
    }

    boolean NestedParenthesesLookahead() {
        if (getToken(1).kind == RPARENT) {
            Token t;
            int i = 2;
            do {
                t = getToken(i++);
            } while (t.noneOfKind(RPARENT, LT, GT, DOUBLE_QUOTE, SINGLE_QUOTE, SPACE, EOL, EOF));

            return t.kind == RPARENT;
        }

        return getToken(1).noneOfKind(RPARENT, LT, GT, DOUBLE_QUOTE, SINGLE_QUOTE, SPACE, EOL, EOF);
    }

  final public void Document() throws ParseException {
                             /*@bgen(jjtree) Document */
  Document jjtn000 = new Document(JJTDOCUMENT);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      label_1:
      while (true) {
        if (jj_2_1(1)) {
          ;
        } else {
          break label_1;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EOL:
          jj_consume_token(EOL);
          break;
        default:
          jj_la1[0] = jj_gen;
          if (jj_2_3(1)) {
            Element();
            label_2:
            while (true) {
              if (jj_2_2(2)) {
                ;
              } else {
                break label_2;
              }
              jj_consume_token(EOL);
              Element();
            }
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
      jj_consume_token(0);
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Element() throws ParseException {
    if (jj_2_4(2147483647)) {
      DocumentElement();
    } else if (jj_2_5(1)) {
      BlockElement();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void DocumentElement() throws ParseException {
    ResourceDefinition();
  }

  final public void BlockElement() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SHARP:
      Header();
      break;
    default:
      jj_la1[1] = jj_gen;
      if (jj_2_6(2147483647)) {
        SetextHeader();
      } else if (jj_2_7(2147483647)) {
        Whitespace();
      } else if (jj_2_8(2147483647)) {
        Ruler();
      } else if (jj_2_9(2147483647)) {
        Code();
      } else if (jj_2_10(2147483647)) {
        Quote();
      } else if (jj_2_11(2147483647)) {
        List();
      } else if (jj_2_12(2147483647)) {
        Comment();
      } else if (jj_2_13(1)) {
        Paragraph();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void Whitespace() throws ParseException {
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
        jj_consume_token(SPACE);
        break;
      case TAB:
        jj_consume_token(TAB);
        break;
      default:
        jj_la1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
      case TAB:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_3;
      }
    }
  }

  final public void InsignificantWhitespace() throws ParseException {
    jj_consume_token(SPACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SPACE:
      jj_consume_token(SPACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
        jj_consume_token(SPACE);
        break;
      default:
        jj_la1[4] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
  }

  final public void EmptyLine() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SPACE:
    case TAB:
      Whitespace();
      break;
    default:
      jj_la1[6] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EOL:
      jj_consume_token(EOL);
      break;
    case 0:
      jj_consume_token(0);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void Header() throws ParseException {
                         /*@bgen(jjtree) Header */
    Header jjtn000 = new Header(JJTHEADER);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);int level = 1;
    stack.push(jjtn000);
    try {
      level = HeaderPrefix();
      Line();
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SHARP:
          ;
          break;
        default:
          jj_la1[8] = jj_gen;
          break label_4;
        }
        jj_consume_token(SHARP);
      }
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        jjtn000.setLevel(level);
        stack.pop();
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public int HeaderPrefix() throws ParseException {
    int level = 1;
    jj_consume_token(SHARP);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SHARP:
      jj_consume_token(SHARP);
                level++;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SHARP:
        jj_consume_token(SHARP);
                                   level++;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SHARP:
          jj_consume_token(SHARP);
                                                      level++;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SHARP:
            jj_consume_token(SHARP);
                                                                         level++;
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SHARP:
              jj_consume_token(SHARP);
                                                                                            level++;
              break;
            default:
              jj_la1[9] = jj_gen;
              ;
            }
            break;
          default:
            jj_la1[10] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[11] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[12] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
      {if (true) return level;}
    throw new Error("Missing return statement in function");
  }

  final public void SetextHeader() throws ParseException {
                               /*@bgen(jjtree) Header */
  Header jjtn000 = new Header(JJTHEADER);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      Line();
      jj_consume_token(EOL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
        label_5:
        while (true) {
          jj_consume_token(EQ);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case EQ:
            ;
            break;
          default:
            jj_la1[14] = jj_gen;
            break label_5;
          }
        }
                      jjtree.closeNodeScope(jjtn000, true);
                      jjtc000 = false;
                      jjtn000.setLevel(1);
        break;
      case MINUS_RULER:
        jj_consume_token(MINUS_RULER);
                            jjtree.closeNodeScope(jjtn000, true);
                            jjtc000 = false;
                            jjtn000.setLevel(2);
        break;
      case MINUS:
        jj_consume_token(MINUS);
                      jjtree.closeNodeScope(jjtn000, true);
                      jjtc000 = false;
                      jjtn000.setLevel(2);
        break;
      default:
        jj_la1[15] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Ruler() throws ParseException {
                       /*@bgen(jjtree) Ruler */
  Ruler jjtn000 = new Ruler(JJTRULER);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
        InsignificantWhitespace();
        break;
      default:
        jj_la1[16] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case UNDERSCORE_RULER:
        jj_consume_token(UNDERSCORE_RULER);
        break;
      case MINUS_RULER:
        jj_consume_token(MINUS_RULER);
        break;
      case ASTERISK_RULER:
        jj_consume_token(ASTERISK_RULER);
        break;
      default:
        jj_la1[17] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Quote() throws ParseException {
                       /*@bgen(jjtree) Quote */
    Quote jjtn000 = new Quote(JJTQUOTE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);stack.push(jjtn000);
    currentQuoteLevel++;
    try {
      QuotePrefix();
      BlockElement();
      label_6:
      while (true) {
        if (QuotedElementLookahead()) {
          ;
        } else {
          break label_6;
        }
        jj_consume_token(EOL);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case TAB:
        case GT:
          if (jj_2_15(2147483647)) {
                                                           Line jjtn001 = new Line(JJTLINE);
                                                           boolean jjtc001 = true;
                                                           jjtree.openNodeScope(jjtn001);
            try {
              Whitespace();
            } catch (Throwable jjte001) {
                                                           if (jjtc001) {
                                                             jjtree.clearNodeScope(jjtn001);
                                                             jjtc001 = false;
                                                           } else {
                                                             jjtree.popNode();
                                                           }
                                                           if (jjte001 instanceof RuntimeException) {
                                                             {if (true) throw (RuntimeException)jjte001;}
                                                           }
                                                           if (jjte001 instanceof ParseException) {
                                                             {if (true) throw (ParseException)jjte001;}
                                                           }
                                                           {if (true) throw (Error)jjte001;}
            } finally {
                                                           if (jjtc001) {
                                                             jjtree.closeNodeScope(jjtn001, true);
                                                           }
            }
          } else if (jj_2_16(2147483647)) {
            QuotePrefix();
            if (jj_2_14(1)) {
              BlockElement();
            } else {
              ;
            }
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[18] = jj_gen;
          ;
        }
      }
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
    currentQuoteLevel--;
    stack.pop();
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void QuotePrefix() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SPACE:
      InsignificantWhitespace();
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
    jj_consume_token(GT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SPACE:
      jj_consume_token(SPACE);
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
  }

  final public void Code() throws ParseException {
                     /*@bgen(jjtree) Code */
  Code jjtn000 = new Code(JJTCODE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      CodeLine();
      label_7:
      while (true) {
        if (CodeLineLookahead()) {
          ;
        } else {
          break label_7;
        }
        jj_consume_token(EOL);
        label_8:
        while (true) {
          if (jj_2_17(2147483647)) {
            ;
          } else {
            break label_8;
          }
          QuotePrefix();
        }
        if (jj_2_18(2147483647)) {
                                                           Line jjtn001 = new Line(JJTLINE);
                                                           boolean jjtc001 = true;
                                                           jjtree.openNodeScope(jjtn001);
          try {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SPACE:
            case TAB:
              Whitespace();
              break;
            default:
              jj_la1[21] = jj_gen;
              ;
            }
          } catch (Throwable jjte001) {
                                                           if (jjtc001) {
                                                             jjtree.clearNodeScope(jjtn001);
                                                             jjtc001 = false;
                                                           } else {
                                                             jjtree.popNode();
                                                           }
                                                           if (jjte001 instanceof RuntimeException) {
                                                             {if (true) throw (RuntimeException)jjte001;}
                                                           }
                                                           if (jjte001 instanceof ParseException) {
                                                             {if (true) throw (ParseException)jjte001;}
                                                           }
                                                           {if (true) throw (Error)jjte001;}
          } finally {
                                                           if (jjtc001) {
                                                             jjtree.closeNodeScope(jjtn001, true);
                                                           }
          }
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
            CodeLine();
            break;
          default:
            jj_la1[22] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void CodeLine() throws ParseException {
                         /*@bgen(jjtree) Line */
  Line jjtn000 = new Line(JJTLINE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      CodeLinePrefix();
      CodeText();
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void CodeLinePrefix() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SPACE:
      jj_consume_token(SPACE);
      jj_consume_token(SPACE);
      jj_consume_token(SPACE);
      jj_consume_token(SPACE);
      break;
    case TAB:
      jj_consume_token(TAB);
      break;
    default:
      jj_la1[23] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void CodeText() throws ParseException {
                             /*@bgen(jjtree) CodeText */
    CodeText jjtn000 = new CodeText(JJTCODETEXT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    Token prev = null;
    try {
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case TAB:
        case AMPERSAND:
        case BACKTICK:
        case EXCLAMATION:
        case SHARP:
        case GT:
        case SINGLE_QUOTE:
        case DOUBLE_QUOTE:
        case LT:
        case LBRACKET:
        case LPARENT:
        case RBRACKET:
        case RPARENT:
        case COLON:
        case SLASH:
        case BACKSLASH:
        case EQ:
        case PLUS:
        case MINUS:
        case ASTERISK:
        case UNDERSCORE_RULER:
        case MINUS_RULER:
        case ASTERISK_RULER:
        case OP_COMMENT:
        case CL_COMMENT:
        case CHAR_ENTITY_REF:
        case CODE_SPAN:
        case EMPHASIS_ITALIC:
        case EMPHASIS_BOLD:
        case EMPHASIS_ITALIC_BOLD:
        case ESCAPED_CHAR:
        case NUMBERING:
        case NUMERIC_CHAR_REF:
        case TEXT:
          ;
          break;
        default:
          jj_la1[24] = jj_gen;
          break label_9;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case AMPERSAND:
        case BACKTICK:
        case EXCLAMATION:
        case SHARP:
        case GT:
        case SINGLE_QUOTE:
        case DOUBLE_QUOTE:
        case LT:
        case LBRACKET:
        case LPARENT:
        case RBRACKET:
        case RPARENT:
        case COLON:
        case SLASH:
        case BACKSLASH:
        case EQ:
        case PLUS:
        case MINUS:
        case ASTERISK:
        case UNDERSCORE_RULER:
        case MINUS_RULER:
        case ASTERISK_RULER:
        case OP_COMMENT:
        case CL_COMMENT:
        case CHAR_ENTITY_REF:
        case CODE_SPAN:
        case EMPHASIS_ITALIC:
        case EMPHASIS_BOLD:
        case EMPHASIS_ITALIC_BOLD:
        case ESCAPED_CHAR:
        case NUMBERING:
        case NUMERIC_CHAR_REF:
        case TEXT:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            t = jj_consume_token(SPACE);
            break;
          case AMPERSAND:
            t = jj_consume_token(AMPERSAND);
            break;
          case BACKTICK:
            t = jj_consume_token(BACKTICK);
            break;
          case EMPHASIS_ITALIC:
            t = jj_consume_token(EMPHASIS_ITALIC);
            break;
          case EMPHASIS_BOLD:
            t = jj_consume_token(EMPHASIS_BOLD);
            break;
          case EMPHASIS_ITALIC_BOLD:
            t = jj_consume_token(EMPHASIS_ITALIC_BOLD);
            break;
          case ESCAPED_CHAR:
            t = jj_consume_token(ESCAPED_CHAR);
            break;
          case EXCLAMATION:
            t = jj_consume_token(EXCLAMATION);
            break;
          case NUMERIC_CHAR_REF:
            t = jj_consume_token(NUMERIC_CHAR_REF);
            break;
          case CHAR_ENTITY_REF:
            t = jj_consume_token(CHAR_ENTITY_REF);
            break;
          case TEXT:
            t = jj_consume_token(TEXT);
            break;
          case SHARP:
            t = jj_consume_token(SHARP);
            break;
          case LPARENT:
            t = jj_consume_token(LPARENT);
            break;
          case RPARENT:
            t = jj_consume_token(RPARENT);
            break;
          case LBRACKET:
            t = jj_consume_token(LBRACKET);
            break;
          case RBRACKET:
            t = jj_consume_token(RBRACKET);
            break;
          case CODE_SPAN:
            t = jj_consume_token(CODE_SPAN);
            break;
          case COLON:
            t = jj_consume_token(COLON);
            break;
          case SLASH:
            t = jj_consume_token(SLASH);
            break;
          case BACKSLASH:
            t = jj_consume_token(BACKSLASH);
            break;
          case GT:
            t = jj_consume_token(GT);
            break;
          case LT:
            t = jj_consume_token(LT);
            break;
          case MINUS:
            t = jj_consume_token(MINUS);
            break;
          case PLUS:
            t = jj_consume_token(PLUS);
            break;
          case ASTERISK:
            t = jj_consume_token(ASTERISK);
            break;
          case UNDERSCORE_RULER:
            t = jj_consume_token(UNDERSCORE_RULER);
            break;
          case MINUS_RULER:
            t = jj_consume_token(MINUS_RULER);
            break;
          case NUMBERING:
            t = jj_consume_token(NUMBERING);
            break;
          case ASTERISK_RULER:
            t = jj_consume_token(ASTERISK_RULER);
            break;
          case EQ:
            t = jj_consume_token(EQ);
            break;
          case SINGLE_QUOTE:
            t = jj_consume_token(SINGLE_QUOTE);
            break;
          case DOUBLE_QUOTE:
            t = jj_consume_token(DOUBLE_QUOTE);
            break;
          case OP_COMMENT:
            t = jj_consume_token(OP_COMMENT);
            break;
          case CL_COMMENT:
            t = jj_consume_token(CL_COMMENT);
            break;
          default:
            jj_la1[25] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                jjtn000.append(t.image);
          break;
        case TAB:
          t = jj_consume_token(TAB);
                          jjtn000.append(getTabWhitespace(prev, t));
          break;
        default:
          jj_la1[26] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            prev = t;
      }
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void ResourceDefinition() throws ParseException {
                                                 /*@bgen(jjtree) ResourceDefinition */
    ResourceDefinition jjtn000 = new ResourceDefinition(JJTRESOURCEDEFINITION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);String n = null;
    Resource resource;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
        jj_consume_token(SPACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
          jj_consume_token(SPACE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            jj_consume_token(SPACE);
            break;
          default:
            jj_la1[27] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[28] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      jj_consume_token(LBRACKET);
      n = refname();
      jj_consume_token(RBRACKET);
                            jjtn000.setId(n);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
        jj_consume_token(SPACE);
        break;
      default:
        jj_la1[30] = jj_gen;
        ;
      }
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
      case TAB:
        Whitespace();
        break;
      default:
        jj_la1[31] = jj_gen;
        ;
      }
      resource = Resource();
                            jjtree.closeNodeScope(jjtn000, true);
                            jjtc000 = false;
                            jjtn000.setResource(resource);
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void List() throws ParseException {
                     /*@bgen(jjtree) List */
    List jjtn000 = new List(JJTLIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);stack.push(jjtn000);
    try {
      label_10:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case TAB:
        case GT:
          ;
          break;
        default:
          jj_la1[32] = jj_gen;
          break label_10;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
          jj_consume_token(SPACE);
          break;
        case TAB:
          jj_consume_token(TAB);
          break;
        case GT:
          jj_consume_token(GT);
          break;
        default:
          jj_la1[33] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      Item();
      label_11:
      while (true) {
        if (ItemLookahead()) {
          ;
        } else {
          break label_11;
        }
        jj_consume_token(EOL);
        label_12:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
          case GT:
            ;
            break;
          default:
            jj_la1[34] = jj_gen;
            break label_12;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            jj_consume_token(SPACE);
            break;
          case TAB:
            jj_consume_token(TAB);
            break;
          case GT:
            jj_consume_token(GT);
            break;
          default:
            jj_la1[35] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
        case MINUS:
        case ASTERISK:
        case NUMBERING:
          Item();
          break;
        default:
          jj_la1[36] = jj_gen;
          ;
        }
      }
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        stack.pop();
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Item() throws ParseException {
                     /*@bgen(jjtree) Item */
    Item jjtn000 = new Item(JJTITEM);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);stack.push(jjtn000);
    Token t;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        t = jj_consume_token(PLUS);
        break;
      case MINUS:
        t = jj_consume_token(MINUS);
        break;
      case ASTERISK:
        t = jj_consume_token(ASTERISK);
        break;
      case NUMBERING:
        t = jj_consume_token(NUMBERING);
                                jjtn000.makeOrdered();
        break;
      default:
        jj_la1[37] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
        jj_consume_token(SPACE);
        break;
      case TAB:
        jj_consume_token(TAB);
        break;
      default:
        jj_la1[38] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        jjtn000.setIndentation(t.beginColumn);
      Paragraph();
      label_13:
      while (true) {
        if (jj_2_19(1)) {
          ;
        } else {
          break label_13;
        }
        if (ParagraphLookahead()) {
          jj_consume_token(EOL);
          label_14:
          while (true) {
            if (jj_2_20(2147483647)) {
              ;
            } else {
              break label_14;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SPACE:
            case TAB:
              Whitespace();
              break;
            default:
              jj_la1[39] = jj_gen;
              ;
            }
            jj_consume_token(EOL);
          }
          Paragraph();
                                                                                                                      jjtn000.makeLoose();
        } else if (ListLookahead()) {
          jj_consume_token(EOL);
          label_15:
          while (true) {
            if (jj_2_21(2147483647)) {
              ;
            } else {
              break label_15;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SPACE:
            case TAB:
              Whitespace();
              break;
            default:
              jj_la1[40] = jj_gen;
              ;
            }
            jj_consume_token(EOL);
          }
          List();
        } else if (LooseLookahead()) {
          jj_consume_token(EOL);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
            Whitespace();
            break;
          default:
            jj_la1[41] = jj_gen;
            ;
          }
                                                                    jjtn000.makeLoose();
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        Item item = (Item)stack.pop();
        List list = (List)stack.peek();
        if (list.getIndentation() == 0) {
            list.setIndentation(item.getIndentation());
        }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Paragraph() throws ParseException {
                               /*@bgen(jjtree) Paragraph */
  Paragraph jjtn000 = new Paragraph(JJTPARAGRAPH);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      Line();
      label_16:
      while (true) {
        if (LineLookahead()) {
          ;
        } else {
          break label_16;
        }
        jj_consume_token(EOL);
        label_17:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
          case GT:
            ;
            break;
          default:
            jj_la1[42] = jj_gen;
            break label_17;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            jj_consume_token(SPACE);
            break;
          case TAB:
            jj_consume_token(TAB);
            break;
          case GT:
            jj_consume_token(GT);
            break;
          default:
            jj_la1[43] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        Line();
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Line() throws ParseException {
                     /*@bgen(jjtree) Line */
  Line jjtn000 = new Line(JJTLINE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      label_18:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHAR_ENTITY_REF:
        case NUMERIC_CHAR_REF:
          CharRef();
          break;
        case CODE_SPAN:
          CodeSpan();
          break;
        case EMPHASIS_ITALIC:
        case EMPHASIS_BOLD:
        case EMPHASIS_ITALIC_BOLD:
          Emphasis();
          break;
        default:
          jj_la1[44] = jj_gen;
          if (jj_2_22(2147483647)) {
            InlineURL();
          } else if (jj_2_23(2147483647)) {
            Tag();
          } else if (jj_2_24(2147483647)) {
            Image();
          } else if (jj_2_25(2147483647)) {
            Link();
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SPACE:
            case TAB:
            case AMPERSAND:
            case BACKTICK:
            case SHARP:
            case GT:
            case SINGLE_QUOTE:
            case DOUBLE_QUOTE:
            case LT:
            case LBRACKET:
            case LPARENT:
            case RBRACKET:
            case RPARENT:
            case COLON:
            case SLASH:
            case BACKSLASH:
            case EQ:
            case PLUS:
            case MINUS:
            case ASTERISK:
            case UNDERSCORE_RULER:
            case MINUS_RULER:
            case ASTERISK_RULER:
            case ESCAPED_CHAR:
            case NUMBERING:
            case TEXT:
              Text();
              break;
            default:
              jj_la1[45] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        if (TextLookahead()) {
          ;
        } else {
          break label_18;
        }
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Text() throws ParseException {
                     /*@bgen(jjtree) Text */
    Text jjtn000 = new Text(JJTTEXT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ESCAPED_CHAR:
        t = jj_consume_token(ESCAPED_CHAR);
                             jjtree.closeNodeScope(jjtn000, true);
                             jjtc000 = false;
                             jjtn000.append(getEscapedChar(t));
        break;
      case SPACE:
      case TAB:
      case AMPERSAND:
      case BACKTICK:
      case SHARP:
      case GT:
      case SINGLE_QUOTE:
      case DOUBLE_QUOTE:
      case LT:
      case LBRACKET:
      case LPARENT:
      case RBRACKET:
      case RPARENT:
      case COLON:
      case SLASH:
      case BACKSLASH:
      case EQ:
      case PLUS:
      case MINUS:
      case ASTERISK:
      case UNDERSCORE_RULER:
      case MINUS_RULER:
      case ASTERISK_RULER:
      case NUMBERING:
      case TEXT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TEXT:
          t = jj_consume_token(TEXT);
          break;
        case SHARP:
          t = jj_consume_token(SHARP);
          break;
        case SPACE:
          t = jj_consume_token(SPACE);
          break;
        case TAB:
          t = jj_consume_token(TAB);
          break;
        case AMPERSAND:
          t = jj_consume_token(AMPERSAND);
          break;
        case BACKTICK:
          t = jj_consume_token(BACKTICK);
          break;
        case LPARENT:
          t = jj_consume_token(LPARENT);
          break;
        case RPARENT:
          t = jj_consume_token(RPARENT);
          break;
        case LBRACKET:
          t = jj_consume_token(LBRACKET);
          break;
        case RBRACKET:
          t = jj_consume_token(RBRACKET);
          break;
        case COLON:
          t = jj_consume_token(COLON);
          break;
        case SLASH:
          t = jj_consume_token(SLASH);
          break;
        case BACKSLASH:
          t = jj_consume_token(BACKSLASH);
          break;
        case GT:
          t = jj_consume_token(GT);
          break;
        case LT:
          t = jj_consume_token(LT);
          break;
        case MINUS:
          t = jj_consume_token(MINUS);
          break;
        case PLUS:
          t = jj_consume_token(PLUS);
          break;
        case NUMBERING:
          t = jj_consume_token(NUMBERING);
          break;
        case ASTERISK:
          t = jj_consume_token(ASTERISK);
          break;
        case UNDERSCORE_RULER:
          t = jj_consume_token(UNDERSCORE_RULER);
          break;
        case MINUS_RULER:
          t = jj_consume_token(MINUS_RULER);
          break;
        case ASTERISK_RULER:
          t = jj_consume_token(ASTERISK_RULER);
          break;
        case EQ:
          t = jj_consume_token(EQ);
          break;
        case SINGLE_QUOTE:
          t = jj_consume_token(SINGLE_QUOTE);
          break;
        case DOUBLE_QUOTE:
          t = jj_consume_token(DOUBLE_QUOTE);
          break;
        default:
          jj_la1[46] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
            jjtn000.append(t.image);
        break;
      default:
        jj_la1[47] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

  final public void CharRef() throws ParseException {
                           /*@bgen(jjtree) CharRef */
    CharRef jjtn000 = new CharRef(JJTCHARREF);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NUMERIC_CHAR_REF:
        t = jj_consume_token(NUMERIC_CHAR_REF);
        break;
      case CHAR_ENTITY_REF:
        t = jj_consume_token(CHAR_ENTITY_REF);
        break;
      default:
        jj_la1[48] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                                         jjtree.closeNodeScope(jjtn000, true);
                                                         jjtc000 = false;
                                                         jjtn000.setValue(t.image);
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void CodeSpan() throws ParseException {
                             /*@bgen(jjtree) CodeSpan */
    CodeSpan jjtn000 = new CodeSpan(JJTCODESPAN);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    try {
      t = jj_consume_token(CODE_SPAN);
                      jjtree.closeNodeScope(jjtn000, true);
                      jjtc000 = false;
                      jjtn000.setText(getValue(t));
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Emphasis() throws ParseException {
                             /*@bgen(jjtree) Emphasis */
    Emphasis jjtn000 = new Emphasis(JJTEMPHASIS);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    int markLength = 1;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EMPHASIS_ITALIC:
        t = jj_consume_token(EMPHASIS_ITALIC);
        break;
      case EMPHASIS_BOLD:
        t = jj_consume_token(EMPHASIS_BOLD);
                                markLength = 2; jjtn000.makeBold();
        break;
      case EMPHASIS_ITALIC_BOLD:
        t = jj_consume_token(EMPHASIS_ITALIC_BOLD);
                                       markLength = 3; jjtn000.makeItalicAndBold();
        break;
      default:
        jj_la1[49] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        jjtree.closeNodeScope(jjtn000, true);
        jjtc000 = false;
        jjtn000.setText(getValue(t, markLength));
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Comment() throws ParseException {
                           /*@bgen(jjtree) Comment */
    Comment jjtn000 = new Comment(JJTCOMMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);StringBuilder buff = new StringBuilder();
    Token t;
    try {
      jj_consume_token(OP_COMMENT);
      label_19:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case TAB:
        case EOL:
        case AMPERSAND:
        case BACKTICK:
        case EXCLAMATION:
        case SHARP:
        case GT:
        case LT:
        case LBRACKET:
        case LPARENT:
        case RBRACKET:
        case RPARENT:
        case COLON:
        case SLASH:
        case BACKSLASH:
        case EQ:
        case UNDERSCORE_RULER:
        case MINUS_RULER:
        case ASTERISK_RULER:
        case TEXT:
          ;
          break;
        default:
          jj_la1[50] = jj_gen;
          break label_19;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TEXT:
          t = jj_consume_token(TEXT);
          break;
        case SPACE:
          t = jj_consume_token(SPACE);
          break;
        case TAB:
          t = jj_consume_token(TAB);
          break;
        case AMPERSAND:
          t = jj_consume_token(AMPERSAND);
          break;
        case BACKTICK:
          t = jj_consume_token(BACKTICK);
          break;
        case EXCLAMATION:
          t = jj_consume_token(EXCLAMATION);
          break;
        case SHARP:
          t = jj_consume_token(SHARP);
          break;
        case GT:
          t = jj_consume_token(GT);
          break;
        case LT:
          t = jj_consume_token(LT);
          break;
        case LPARENT:
          t = jj_consume_token(LPARENT);
          break;
        case RPARENT:
          t = jj_consume_token(RPARENT);
          break;
        case LBRACKET:
          t = jj_consume_token(LBRACKET);
          break;
        case RBRACKET:
          t = jj_consume_token(RBRACKET);
          break;
        case COLON:
          t = jj_consume_token(COLON);
          break;
        case SLASH:
          t = jj_consume_token(SLASH);
          break;
        case BACKSLASH:
          t = jj_consume_token(BACKSLASH);
          break;
        case EQ:
          t = jj_consume_token(EQ);
          break;
        case MINUS_RULER:
          t = jj_consume_token(MINUS_RULER);
          break;
        case UNDERSCORE_RULER:
          t = jj_consume_token(UNDERSCORE_RULER);
          break;
        case ASTERISK_RULER:
          t = jj_consume_token(ASTERISK_RULER);
          break;
        case EOL:
          t = jj_consume_token(EOL);
          break;
        default:
          jj_la1[51] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            buff.append(t.image);
      }
      jjtn000.setText(buff.toString());
      jj_consume_token(CL_COMMENT);
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void InlineURL() throws ParseException {
                               /*@bgen(jjtree) InlineUrl */
    InlineUrl jjtn000 = new InlineUrl(JJTINLINEURL);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    StringBuilder buff = new StringBuilder();
    try {
      jj_consume_token(LT);
      t = jj_consume_token(TEXT);
                 buff.append(t.image);
      jj_consume_token(COLON);
          buff.append(":");
      label_20:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SLASH:
          ;
          break;
        default:
          jj_la1[52] = jj_gen;
          break label_20;
        }
        jj_consume_token(SLASH);
            buff.append("/");
      }
      t = jj_consume_token(TEXT);
                 buff.append(t.image);
      label_21:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case AMPERSAND:
        case SLASH:
        case EQ:
        case TEXT:
          ;
          break;
        default:
          jj_la1[53] = jj_gen;
          break label_21;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TEXT:
          t = jj_consume_token(TEXT);
                     buff.append(t.image);
          break;
        case SLASH:
          jj_consume_token(SLASH);
                buff.append("/");
          break;
        case AMPERSAND:
          jj_consume_token(AMPERSAND);
                buff.append("&");
          break;
        case EQ:
          jj_consume_token(EQ);
                buff.append("=");
          break;
        default:
          jj_la1[54] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(GT);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setUrl(buff.toString());
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Link() throws ParseException {
                     /*@bgen(jjtree) Link */
    Link jjtn000 = new Link(JJTLINK);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);String text, reference = "";
    Resource resource = null;
    try {
      jj_consume_token(LBRACKET);
      label_22:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHAR_ENTITY_REF:
        case NUMERIC_CHAR_REF:
          CharRef();
          break;
        case CODE_SPAN:
          CodeSpan();
          break;
        case EMPHASIS_ITALIC:
        case EMPHASIS_BOLD:
        case EMPHASIS_ITALIC_BOLD:
          Emphasis();
          break;
        default:
          jj_la1[55] = jj_gen;
          if (jj_2_26(2147483647)) {
            InlineURL();
          } else if (jj_2_27(2147483647)) {
            Image();
          } else if (jj_2_28(2147483647)) {
            Link();
          } else if (getToken(1).noneOfKind(RBRACKET, EOL, EOF)) {
            Text();
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case EOL:
            Text jjtn001 = new Text(JJTTEXT);
            boolean jjtc001 = true;
            jjtree.openNodeScope(jjtn001);
              try {
                jj_consume_token(EOL);
              } finally {
            if (jjtc001) {
              jjtree.closeNodeScope(jjtn001, true);
            }
              }
                        ((Text)jjtree.peekNode()).append("\u005cn");
              break;
            default:
              jj_la1[56] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        if (jj_2_29(1)) {
          ;
        } else {
          break label_22;
        }
      }
      jj_consume_token(RBRACKET);
      if (jj_2_31(3)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case EOL:
        case LBRACKET:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            jj_consume_token(SPACE);
                        jjtn000.setWhitespaceAtMiddle();
            break;
          default:
            jj_la1[57] = jj_gen;
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case EOL:
            jj_consume_token(EOL);
            break;
          default:
            jj_la1[58] = jj_gen;
            ;
          }
          jj_consume_token(LBRACKET);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
          case AMPERSAND:
          case GT:
          case LT:
          case LBRACKET:
          case LPARENT:
          case RPARENT:
          case COLON:
          case SLASH:
          case BACKSLASH:
          case EQ:
          case TEXT:
            reference = refname();
            break;
          default:
            jj_la1[59] = jj_gen;
            ;
          }
                  jjtn000.setReference(reference);
          jj_consume_token(RBRACKET);
          break;
        case LPARENT:
          jj_consume_token(LPARENT);
          if (jj_2_30(1)) {
            resource = Resource();
          } else {
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
            Whitespace();
            break;
          default:
            jj_la1[60] = jj_gen;
            ;
          }
                  jjtn000.setResource(resource);
          jj_consume_token(RPARENT);
          break;
        default:
          jj_la1[61] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else {
        ;
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Image() throws ParseException {
                       /*@bgen(jjtree) Image */
    Image jjtn000 = new Image(JJTIMAGE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);String text, reference;
    Resource resource = null;
    try {
      jj_consume_token(EXCLAMATION);
      jj_consume_token(LBRACKET);
      text = refname();
                       jjtn000.setText(text);
      jj_consume_token(RBRACKET);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
      case LBRACKET:
      case LPARENT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case LBRACKET:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            jj_consume_token(SPACE);
            break;
          default:
            jj_la1[62] = jj_gen;
            ;
          }
          jj_consume_token(LBRACKET);
          reference = refname();
                                jjtn000.setReference(reference);
          jj_consume_token(RBRACKET);
          break;
        case LPARENT:
          jj_consume_token(LPARENT);
          if (jj_2_32(1)) {
            resource = Resource();
                                     jjtn000.setResource(resource);
          } else {
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
          case TAB:
            Whitespace();
            break;
          default:
            jj_la1[63] = jj_gen;
            ;
          }
          jj_consume_token(RPARENT);
          break;
        default:
          jj_la1[64] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[65] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void Tag() throws ParseException {
    Token t;
    TagAttribute attribute;
    java.util.List<TagAttribute> attributes = new java.util.ArrayList<TagAttribute>();
    if (jj_2_34(2)) {
      jj_consume_token(LT);
      jj_consume_token(SLASH);
      t = jj_consume_token(TEXT);
                          ClosingTag jjtn001 = new ClosingTag(JJTCLOSINGTAG);
                          boolean jjtc001 = true;
                          jjtree.openNodeScope(jjtn001);
      try {
        jj_consume_token(GT);
      } finally {
                          if (jjtc001) {
                            jjtree.closeNodeScope(jjtn001, true);
                          }
      }
        ClosingTag closing = ((ClosingTag)jjtree.peekNode());
        closing.setName(t.image);
        if (markupStack.size() > 0) {
            OpeningTag opening = (OpeningTag)markupStack.peek();
            if (opening.getName().equals(closing.getName())) {
                opening.setClosingTag(closing);
                markupStack.pop();
            } else {
                markupStack.clear();
            }
        }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
        t = jj_consume_token(TEXT);
        label_23:
        while (true) {
          if (jj_2_33(2147483647)) {
            ;
          } else {
            break label_23;
          }
          label_24:
          while (true) {
            jj_consume_token(SPACE);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SPACE:
              ;
              break;
            default:
              jj_la1[66] = jj_gen;
              break label_24;
            }
          }
          attribute = TagAttribute();
                                                  attributes.add(attribute);
        }
        label_25:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SPACE:
            ;
            break;
          default:
            jj_la1[67] = jj_gen;
            break label_25;
          }
          jj_consume_token(SPACE);
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SLASH:
          jj_consume_token(SLASH);
              EmptyTag jjtn002 = new EmptyTag(JJTEMPTYTAG);
              boolean jjtc002 = true;
              jjtree.openNodeScope(jjtn002);
          try {
            jj_consume_token(GT);
          } finally {
              if (jjtc002) {
                jjtree.closeNodeScope(jjtn002, true);
              }
          }
                            EmptyTag emptytag = (EmptyTag)jjtree.peekNode(); emptytag.setName(t.image); emptytag.setAttributes(attributes);
          break;
        case GT:
            OpeningTag jjtn003 = new OpeningTag(JJTOPENINGTAG);
            boolean jjtc003 = true;
            jjtree.openNodeScope(jjtn003);
          try {
            jj_consume_token(GT);
          } finally {
            if (jjtc003) {
              jjtree.closeNodeScope(jjtn003, true);
            }
          }
                            OpeningTag opening = (OpeningTag)jjtree.peekNode(); opening.setName(t.image); opening.setAttributes(attributes); markupStack.push(opening);
          break;
        default:
          jj_la1[68] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[69] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public TagAttribute TagAttribute() throws ParseException {
    StringBuilder buff = new StringBuilder();
    Token attrName;
    Token t;
    attrName = jj_consume_token(TEXT);
    jj_consume_token(EQ);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLE_QUOTE:
      jj_consume_token(DOUBLE_QUOTE);
      label_26:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case TAB:
        case AMPERSAND:
        case BACKTICK:
        case GT:
        case SINGLE_QUOTE:
        case LT:
        case LPARENT:
        case RPARENT:
        case SLASH:
        case BACKSLASH:
        case CODE_SPAN:
        case ESCAPED_CHAR:
        case TEXT:
          ;
          break;
        default:
          jj_la1[70] = jj_gen;
          break label_26;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CODE_SPAN:
          t = jj_consume_token(CODE_SPAN);
          break;
        case ESCAPED_CHAR:
          t = jj_consume_token(ESCAPED_CHAR);
          break;
        case SPACE:
          t = jj_consume_token(SPACE);
          break;
        case TAB:
          t = jj_consume_token(TAB);
          break;
        case TEXT:
          t = jj_consume_token(TEXT);
          break;
        case AMPERSAND:
          t = jj_consume_token(AMPERSAND);
          break;
        case LPARENT:
          t = jj_consume_token(LPARENT);
          break;
        case RPARENT:
          t = jj_consume_token(RPARENT);
          break;
        case LT:
          t = jj_consume_token(LT);
          break;
        case GT:
          t = jj_consume_token(GT);
          break;
        case SLASH:
          t = jj_consume_token(SLASH);
          break;
        case BACKSLASH:
          t = jj_consume_token(BACKSLASH);
          break;
        case SINGLE_QUOTE:
          t = jj_consume_token(SINGLE_QUOTE);
          break;
        case BACKTICK:
          t = jj_consume_token(BACKTICK);
          break;
        default:
          jj_la1[71] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                buff.append(t.image);
      }
      jj_consume_token(DOUBLE_QUOTE);
      break;
    case SINGLE_QUOTE:
      jj_consume_token(SINGLE_QUOTE);
      label_27:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SPACE:
        case TAB:
        case AMPERSAND:
        case BACKTICK:
        case GT:
        case DOUBLE_QUOTE:
        case LT:
        case LPARENT:
        case RPARENT:
        case SLASH:
        case BACKSLASH:
        case CODE_SPAN:
        case ESCAPED_CHAR:
        case TEXT:
          ;
          break;
        default:
          jj_la1[72] = jj_gen;
          break label_27;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CODE_SPAN:
          t = jj_consume_token(CODE_SPAN);
          break;
        case ESCAPED_CHAR:
          t = jj_consume_token(ESCAPED_CHAR);
          break;
        case SPACE:
          t = jj_consume_token(SPACE);
          break;
        case TAB:
          t = jj_consume_token(TAB);
          break;
        case TEXT:
          t = jj_consume_token(TEXT);
          break;
        case AMPERSAND:
          t = jj_consume_token(AMPERSAND);
          break;
        case LPARENT:
          t = jj_consume_token(LPARENT);
          break;
        case RPARENT:
          t = jj_consume_token(RPARENT);
          break;
        case LT:
          t = jj_consume_token(LT);
          break;
        case GT:
          t = jj_consume_token(GT);
          break;
        case SLASH:
          t = jj_consume_token(SLASH);
          break;
        case BACKSLASH:
          t = jj_consume_token(BACKSLASH);
          break;
        case DOUBLE_QUOTE:
          t = jj_consume_token(DOUBLE_QUOTE);
          break;
        case BACKTICK:
          t = jj_consume_token(BACKTICK);
          break;
        default:
          jj_la1[73] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                buff.append(t.image);
      }
      jj_consume_token(SINGLE_QUOTE);
      break;
    default:
      jj_la1[74] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return new TagAttribute(attrName.image, buff.toString());}
    throw new Error("Missing return statement in function");
  }

  final public String refname() throws ParseException {
    Token t;
    StringBuilder buff = new StringBuilder();
    label_28:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TEXT:
        t = jj_consume_token(TEXT);
        break;
      case SPACE:
        t = jj_consume_token(SPACE);
        break;
      case TAB:
        t = jj_consume_token(TAB);
        break;
      case AMPERSAND:
        t = jj_consume_token(AMPERSAND);
        break;
      case LPARENT:
        t = jj_consume_token(LPARENT);
        break;
      case RPARENT:
        t = jj_consume_token(RPARENT);
        break;
      case LBRACKET:
        t = jj_consume_token(LBRACKET);
        break;
      case COLON:
        t = jj_consume_token(COLON);
        break;
      case SLASH:
        t = jj_consume_token(SLASH);
        break;
      case BACKSLASH:
        t = jj_consume_token(BACKSLASH);
        break;
      case GT:
        t = jj_consume_token(GT);
        break;
      case LT:
        t = jj_consume_token(LT);
        break;
      case EQ:
        t = jj_consume_token(EQ);
        break;
      default:
        jj_la1[75] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
            buff.append(t.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPACE:
      case TAB:
      case AMPERSAND:
      case GT:
      case LT:
      case LBRACKET:
      case LPARENT:
      case RPARENT:
      case COLON:
      case SLASH:
      case BACKSLASH:
      case EQ:
      case TEXT:
        ;
        break;
      default:
        jj_la1[76] = jj_gen;
        break label_28;
      }
    }
      {if (true) return buff.toString();}
    throw new Error("Missing return statement in function");
  }

  final public Resource Resource() throws ParseException {
    String url;
    String hint = null;
    url = url();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SPACE:
    case TAB:
      Whitespace();
      hint = title();
      break;
    default:
      jj_la1[77] = jj_gen;
      ;
    }
      {if (true) return new Resource(url, hint);}
    throw new Error("Missing return statement in function");
  }

  final public String url() throws ParseException {
    String text;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      text = urltext();
      jj_consume_token(GT);
      break;
    default:
      jj_la1[78] = jj_gen;
      if (jj_2_35(1)) {
        text = urltext();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return text;}
    throw new Error("Missing return statement in function");
  }

  final public String urltext() throws ParseException {
    Token t;
    StringBuilder buff = new StringBuilder();
    label_29:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TEXT:
        t = jj_consume_token(TEXT);
        break;
      case AMPERSAND:
        t = jj_consume_token(AMPERSAND);
        break;
      case LPARENT:
        t = jj_consume_token(LPARENT);
                    parentheses++;
        break;
      default:
        jj_la1[79] = jj_gen;
        if (parentheses > 0) {
          t = jj_consume_token(RPARENT);
                                                 parentheses--;
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            t = jj_consume_token(LBRACKET);
            break;
          case RBRACKET:
            t = jj_consume_token(RBRACKET);
            break;
          case COLON:
            t = jj_consume_token(COLON);
            break;
          case SLASH:
            t = jj_consume_token(SLASH);
            break;
          case BACKSLASH:
            t = jj_consume_token(BACKSLASH);
            break;
          case SHARP:
            t = jj_consume_token(SHARP);
            break;
          case EQ:
            t = jj_consume_token(EQ);
            break;
          default:
            jj_la1[80] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
            buff.append(t.image);
      if (jj_2_36(1)) {
        ;
      } else {
        break label_29;
      }
    }
      parentheses = 0; {if (true) return buff.toString();}
    throw new Error("Missing return statement in function");
  }

  final public String title() throws ParseException {
    String text;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOUBLE_QUOTE:
      jj_consume_token(DOUBLE_QUOTE);
      text = titletext(DOUBLE_QUOTE);
      jj_consume_token(DOUBLE_QUOTE);
      break;
    case SINGLE_QUOTE:
      jj_consume_token(SINGLE_QUOTE);
      text = titletext(SINGLE_QUOTE);
      jj_consume_token(SINGLE_QUOTE);
      break;
    default:
      jj_la1[81] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return text;}
    throw new Error("Missing return statement in function");
  }

  final public String titletext(int quoteType) throws ParseException {
    StringBuilder buff = new StringBuilder();
    Token t;
    label_30:
    while (true) {
      if (QuoteInsideTitleLookahead(quoteType)) {
        ;
      } else {
        break label_30;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TEXT:
        t = jj_consume_token(TEXT);
        break;
      case SPACE:
        t = jj_consume_token(SPACE);
        break;
      case TAB:
        t = jj_consume_token(TAB);
        break;
      case AMPERSAND:
        t = jj_consume_token(AMPERSAND);
        break;
      case LPARENT:
        t = jj_consume_token(LPARENT);
        break;
      case RPARENT:
        t = jj_consume_token(RPARENT);
        break;
      case SLASH:
        t = jj_consume_token(SLASH);
        break;
      case BACKSLASH:
        t = jj_consume_token(BACKSLASH);
        break;
      case SINGLE_QUOTE:
        t = jj_consume_token(SINGLE_QUOTE);
        break;
      case DOUBLE_QUOTE:
        t = jj_consume_token(DOUBLE_QUOTE);
        break;
      default:
        jj_la1[82] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
            buff.append(t.image);
    }
      {if (true) return buff.toString();}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  private boolean jj_3R_92() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_122()) {
    jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    }
    return false;
  }

  private boolean jj_3R_122() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) jj_scanpos = xsp;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_67()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3_3() {
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3_1() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(3)) {
    jj_scanpos = xsp;
    if (jj_3_3()) return true;
    }
    return false;
  }

  private boolean jj_3R_100() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3_30() {
    if (jj_3R_59()) return true;
    return false;
  }

  private boolean jj_3R_49() {
    if (jj_scan_token(EXCLAMATION)) return true;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_67()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_92()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_99() {
    if (jj_3R_67()) return true;
    return false;
  }

  private boolean jj_3R_61() {
    if (jj_scan_token(LPARENT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_30()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_100()) jj_scanpos = xsp;
    if (jj_scan_token(RPARENT)) return true;
    return false;
  }

  private boolean jj_3R_98() {
    if (jj_scan_token(SPACE)) return true;
    return false;
  }

  private boolean jj_3_28() {
    if (jj_3R_50()) return true;
    return false;
  }

  private boolean jj_3R_60() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_98()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(3)) jj_scanpos = xsp;
    if (jj_scan_token(LBRACKET)) return true;
    xsp = jj_scanpos;
    if (jj_3R_99()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3_27() {
    if (jj_3R_49()) return true;
    return false;
  }

  private boolean jj_3_26() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3_31() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) return true;
    }
    return false;
  }

  private boolean jj_3R_58() {
    if (jj_scan_token(EOL)) return true;
    return false;
  }

  private boolean jj_3R_57() {
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_56() {
    if (jj_3R_50()) return true;
    return false;
  }

  private boolean jj_3R_55() {
    if (jj_3R_49()) return true;
    return false;
  }

  private boolean jj_3R_54() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_53() {
    if (jj_3R_95()) return true;
    return false;
  }

  private boolean jj_3R_52() {
    if (jj_3R_94()) return true;
    return false;
  }

  private boolean jj_3R_51() {
    if (jj_3R_93()) return true;
    return false;
  }

  private boolean jj_3_29() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = getToken(1).noneOfKind(RBRACKET, EOL, EOF);
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_50() {
    if (jj_scan_token(LBRACKET)) return true;
    Token xsp;
    if (jj_3_29()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_29()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACKET)) return true;
    xsp = jj_scanpos;
    if (jj_3_31()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_118() {
    if (jj_scan_token(EQ)) return true;
    return false;
  }

  private boolean jj_3R_117() {
    if (jj_scan_token(AMPERSAND)) return true;
    return false;
  }

  private boolean jj_3R_116() {
    if (jj_scan_token(SLASH)) return true;
    return false;
  }

  private boolean jj_3R_90() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) return true;
    }
    }
    }
    return false;
  }

  private boolean jj_3R_115() {
    if (jj_scan_token(TEXT)) return true;
    return false;
  }

  private boolean jj_3R_89() {
    if (jj_scan_token(SLASH)) return true;
    return false;
  }

  private boolean jj_3R_47() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(TEXT)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_89()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(TEXT)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_90()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(GT)) return true;
    return false;
  }

  private boolean jj_3R_86() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(5)) {
    jj_scanpos = xsp;
    if (jj_scan_token(6)) {
    jj_scanpos = xsp;
    if (jj_scan_token(7)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(14)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(3)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_40() {
    if (jj_scan_token(OP_COMMENT)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_86()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CL_COMMENT)) return true;
    return false;
  }

  private boolean jj_3R_125() {
    if (jj_scan_token(EMPHASIS_ITALIC_BOLD)) return true;
    return false;
  }

  private boolean jj_3R_124() {
    if (jj_scan_token(EMPHASIS_BOLD)) return true;
    return false;
  }

  private boolean jj_3R_95() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_3R_124()) {
    jj_scanpos = xsp;
    if (jj_3R_125()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_94() {
    if (jj_scan_token(CODE_SPAN)) return true;
    return false;
  }

  private boolean jj_3R_93() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(35)) {
    jj_scanpos = xsp;
    if (jj_scan_token(28)) return true;
    }
    return false;
  }

  private boolean jj_3_20() {
    if (jj_3R_35()) return true;
    return false;
  }

  private boolean jj_3_21() {
    if (jj_3R_35()) return true;
    return false;
  }

  private boolean jj_3_25() {
    if (jj_3R_50()) return true;
    return false;
  }

  private boolean jj_3_24() {
    if (jj_3R_49()) return true;
    return false;
  }

  private boolean jj_3R_127() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(7)) {
    jj_scanpos = xsp;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(5)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(14)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(21)) {
    jj_scanpos = xsp;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(34)) {
    jj_scanpos = xsp;
    if (jj_scan_token(22)) {
    jj_scanpos = xsp;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) {
    jj_scanpos = xsp;
    if (jj_scan_token(10)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_23() {
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3_22() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_96() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) return true;
    }
    return false;
  }

  private boolean jj_3R_126() {
    if (jj_scan_token(ESCAPED_CHAR)) return true;
    return false;
  }

  private boolean jj_3R_142() {
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_141() {
    if (jj_3R_50()) return true;
    return false;
  }

  private boolean jj_3R_140() {
    if (jj_3R_49()) return true;
    return false;
  }

  private boolean jj_3R_139() {
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_138() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_137() {
    if (jj_3R_95()) return true;
    return false;
  }

  private boolean jj_3R_136() {
    if (jj_3R_94()) return true;
    return false;
  }

  private boolean jj_3R_135() {
    if (jj_3R_93()) return true;
    return false;
  }

  private boolean jj_3R_111() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_135()) {
    jj_scanpos = xsp;
    if (jj_3R_136()) {
    jj_scanpos = xsp;
    if (jj_3R_137()) {
    jj_scanpos = xsp;
    if (jj_3R_138()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) {
    jj_scanpos = xsp;
    if (jj_3R_140()) {
    jj_scanpos = xsp;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_77() {
    Token xsp;
    if (jj_3R_111()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_111()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_41() {
    if (jj_3R_77()) return true;
    return false;
  }

  private boolean jj_3R_46() {
    if (jj_scan_token(EOL)) return true;
    return false;
  }

  private boolean jj_3R_45() {
    if (jj_scan_token(EOL)) return true;
    return false;
  }

  private boolean jj_3R_149() {
    if (jj_scan_token(NUMBERING)) return true;
    return false;
  }

  private boolean jj_3R_44() {
    if (jj_scan_token(EOL)) return true;
    return false;
  }

  private boolean jj_3_19() {
    Token xsp;
    xsp = jj_scanpos;
    jj_lookingAhead = true;
    jj_semLA = ParagraphLookahead();
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_44()) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = ListLookahead();
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_45()) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = LooseLookahead();
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_46()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_155() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) {
    jj_scanpos = xsp;
    if (jj_scan_token(10)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_152() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_155()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_134() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(21)) {
    jj_scanpos = xsp;
    if (jj_scan_token(22)) {
    jj_scanpos = xsp;
    if (jj_3R_149()) return true;
    }
    }
    }
    return false;
  }

  private boolean jj_3R_148() {
    if (jj_scan_token(SINGLE_QUOTE)) return true;
    if (jj_3R_152()) return true;
    if (jj_scan_token(SINGLE_QUOTE)) return true;
    return false;
  }

  private boolean jj_3R_147() {
    if (jj_scan_token(DOUBLE_QUOTE)) return true;
    if (jj_3R_152()) return true;
    if (jj_scan_token(DOUBLE_QUOTE)) return true;
    return false;
  }

  private boolean jj_3R_130() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_147()) {
    jj_scanpos = xsp;
    if (jj_3R_148()) return true;
    }
    return false;
  }

  private boolean jj_3R_102() {
    if (jj_scan_token(SPACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_133() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_110() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_133()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_134()) return true;
    return false;
  }

  private boolean jj_3R_68() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_64() {
    if (jj_scan_token(RPARENT)) return true;
    return false;
  }

  private boolean jj_3R_66() {
    if (jj_scan_token(SPACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_102()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_63() {
    if (jj_scan_token(LPARENT)) return true;
    return false;
  }

  private boolean jj_3R_144() {
    if (jj_scan_token(TAB)) return true;
    return false;
  }

  private boolean jj_3R_32() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_66()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_67()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) jj_scanpos = xsp;
    if (jj_scan_token(COLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_68()) jj_scanpos = xsp;
    if (jj_3R_59()) return true;
    return false;
  }

  private boolean jj_3_36() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    jj_lookingAhead = true;
    jj_semLA = parentheses > 0;
    jj_lookingAhead = false;
    if (!jj_semLA || jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(14)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(7)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_62() {
    Token xsp;
    if (jj_3_36()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_36()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_35() {
    if (jj_3R_62()) return true;
    return false;
  }

  private boolean jj_3R_128() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_62()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  private boolean jj_3R_97() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_128()) {
    jj_scanpos = xsp;
    if (jj_3_35()) return true;
    }
    return false;
  }

  private boolean jj_3R_105() {
    if (jj_3R_104()) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  private boolean jj_3_14() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_59() {
    if (jj_3R_97()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_105()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_143() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(5)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(31)) {
    jj_scanpos = xsp;
    if (jj_scan_token(32)) {
    jj_scanpos = xsp;
    if (jj_scan_token(33)) {
    jj_scanpos = xsp;
    if (jj_scan_token(6)) {
    jj_scanpos = xsp;
    if (jj_scan_token(35)) {
    jj_scanpos = xsp;
    if (jj_scan_token(28)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(7)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(14)) {
    jj_scanpos = xsp;
    if (jj_scan_token(29)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(21)) {
    jj_scanpos = xsp;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(22)) {
    jj_scanpos = xsp;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(34)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) {
    jj_scanpos = xsp;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_scan_token(26)) {
    jj_scanpos = xsp;
    if (jj_scan_token(27)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_114() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_143()) {
    jj_scanpos = xsp;
    if (jj_3R_144()) return true;
    }
    return false;
  }

  private boolean jj_3R_88() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_43() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_88()) jj_scanpos = xsp;
    if (jj_scan_token(EOL)) return true;
    return false;
  }

  private boolean jj_3_18() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_scan_token(0)) return true;
    }
    return false;
  }

  private boolean jj_3R_84() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_114()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_17() {
    if (jj_3R_38()) return true;
    return false;
  }

  private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) return true;
    }
    return false;
  }

  private boolean jj_3R_113() {
    if (jj_scan_token(SPACE)) return true;
    if (jj_scan_token(SPACE)) return true;
    if (jj_scan_token(SPACE)) return true;
    if (jj_scan_token(SPACE)) return true;
    return false;
  }

  private boolean jj_3R_67() {
    Token xsp;
    if (jj_3R_103()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_103()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_37() {
    if (jj_3R_83()) return true;
    if (jj_3R_84()) return true;
    return false;
  }

  private boolean jj_3_16() {
    if (jj_3R_38()) return true;
    return false;
  }

  private boolean jj_3R_87() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_42() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_87()) jj_scanpos = xsp;
    if (jj_scan_token(EOL)) return true;
    return false;
  }

  private boolean jj_3_15() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_42()) {
    jj_scanpos = xsp;
    if (jj_scan_token(0)) return true;
    }
    return false;
  }

  private boolean jj_3R_108() {
    if (jj_3R_37()) return true;
    return false;
  }

  private boolean jj_3R_85() {
    if (jj_3R_82()) return true;
    return false;
  }

  private boolean jj_3R_38() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_85()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_154() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(29)) {
    jj_scanpos = xsp;
    if (jj_scan_token(33)) {
    jj_scanpos = xsp;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_scan_token(5)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_151() {
    if (jj_scan_token(SINGLE_QUOTE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_154()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SINGLE_QUOTE)) return true;
    return false;
  }

  private boolean jj_3R_109() {
    if (jj_3R_38()) return true;
    return false;
  }

  private boolean jj_3R_132() {
    if (jj_3R_82()) return true;
    return false;
  }

  private boolean jj_3R_80() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  private boolean jj_3R_79() {
    if (jj_scan_token(MINUS_RULER)) return true;
    return false;
  }

  private boolean jj_3R_107() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_132()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_78() {
    Token xsp;
    if (jj_scan_token(19)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(19)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_153() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(29)) {
    jj_scanpos = xsp;
    if (jj_scan_token(33)) {
    jj_scanpos = xsp;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(4)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(8)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) {
    jj_scanpos = xsp;
    if (jj_scan_token(5)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_5() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_34() {
    if (jj_3R_77()) return true;
    if (jj_scan_token(EOL)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_78()) {
    jj_scanpos = xsp;
    if (jj_3R_79()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_150() {
    if (jj_scan_token(DOUBLE_QUOTE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_153()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(DOUBLE_QUOTE)) return true;
    return false;
  }

  private boolean jj_3R_131() {
    if (jj_scan_token(SHARP)) return true;
    return false;
  }

  private boolean jj_3_33() {
    Token xsp;
    if (jj_scan_token(1)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(1)) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(TEXT)) return true;
    return false;
  }

  private boolean jj_3R_145() {
    if (jj_scan_token(TEXT)) return true;
    if (jj_scan_token(EQ)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_150()) {
    jj_scanpos = xsp;
    if (jj_3R_151()) return true;
    }
    return false;
  }

  private boolean jj_3R_121() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  private boolean jj_3R_120() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  private boolean jj_3R_106() {
    if (jj_3R_131()) return true;
    return false;
  }

  private boolean jj_3R_112() {
    if (jj_scan_token(SPACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_119() {
    Token xsp;
    if (jj_scan_token(1)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(1)) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_145()) return true;
    return false;
  }

  private boolean jj_3R_81() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_39() {
    if (jj_3R_82()) return true;
    return false;
  }

  private boolean jj_3R_35() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_81()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(3)) {
    jj_scanpos = xsp;
    if (jj_scan_token(0)) return true;
    }
    return false;
  }

  private boolean jj_3_12() {
    if (jj_3R_40()) return true;
    return false;
  }

  private boolean jj_3_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_39()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(21)) {
    jj_scanpos = xsp;
    if (jj_scan_token(22)) {
    jj_scanpos = xsp;
    if (jj_scan_token(34)) return true;
    }
    }
    }
    return false;
  }

  private boolean jj_3R_91() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(TEXT)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_119()) { jj_scanpos = xsp; break; }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(1)) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    }
    return false;
  }

  private boolean jj_3R_36() {
    if (jj_3R_82()) return true;
    return false;
  }

  private boolean jj_3_10() {
    if (jj_3R_38()) return true;
    return false;
  }

  private boolean jj_3_9() {
    if (jj_3R_37()) return true;
    return false;
  }

  private boolean jj_3_8() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_36()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) return true;
    }
    }
    xsp = jj_scanpos;
    if (jj_scan_token(3)) {
    jj_scanpos = xsp;
    if (jj_scan_token(0)) return true;
    }
    return false;
  }

  private boolean jj_3R_82() {
    if (jj_scan_token(SPACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_112()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3_7() {
    if (jj_3R_35()) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_3R_34()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(3)) {
    jj_scanpos = xsp;
    if (jj_scan_token(0)) return true;
    }
    return false;
  }

  private boolean jj_3R_129() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(1)) {
    jj_scanpos = xsp;
    if (jj_scan_token(2)) return true;
    }
    return false;
  }

  private boolean jj_3R_104() {
    Token xsp;
    if (jj_3R_129()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_129()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_13() {
    if (jj_3R_41()) return true;
    return false;
  }

  private boolean jj_3R_76() {
    if (jj_3R_40()) return true;
    return false;
  }

  private boolean jj_3R_75() {
    if (jj_3R_110()) return true;
    return false;
  }

  private boolean jj_3R_74() {
    if (jj_3R_109()) return true;
    return false;
  }

  private boolean jj_3R_73() {
    if (jj_3R_108()) return true;
    return false;
  }

  private boolean jj_3R_72() {
    if (jj_3R_107()) return true;
    return false;
  }

  private boolean jj_3R_71() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_3R_32()) return true;
    return false;
  }

  private boolean jj_3R_70() {
    if (jj_3R_34()) return true;
    return false;
  }

  private boolean jj_3_34() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(SLASH)) return true;
    if (jj_scan_token(TEXT)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  private boolean jj_3R_146() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_48() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_34()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) return true;
    }
    return false;
  }

  private boolean jj_3R_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_69()) {
    jj_scanpos = xsp;
    if (jj_3R_70()) {
    jj_scanpos = xsp;
    if (jj_3R_71()) {
    jj_scanpos = xsp;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) {
    jj_scanpos = xsp;
    if (jj_3R_74()) {
    jj_scanpos = xsp;
    if (jj_3R_75()) {
    jj_scanpos = xsp;
    if (jj_3R_76()) {
    jj_scanpos = xsp;
    if (jj_3_13()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_2() {
    if (jj_scan_token(EOL)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_69() {
    if (jj_3R_106()) return true;
    return false;
  }

  private boolean jj_3_32() {
    if (jj_3R_59()) return true;
    return false;
  }

  private boolean jj_3R_101() {
    if (jj_3R_32()) return true;
    return false;
  }

  private boolean jj_3R_123() {
    if (jj_scan_token(LPARENT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_32()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_146()) jj_scanpos = xsp;
    if (jj_scan_token(RPARENT)) return true;
    return false;
  }

  private boolean jj_3R_65() {
    if (jj_3R_101()) return true;
    return false;
  }

  private boolean jj_3R_31() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_65()) {
    jj_scanpos = xsp;
    if (jj_3_5()) return true;
    }
    return false;
  }

  /** Generated Token Manager. */
  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  /** Whether we are looking ahead. */
  private boolean jj_lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[83];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x8,0x80,0x6,0x6,0x2,0x2,0x6,0x9,0x80,0x80,0x80,0x80,0x80,0x80,0x80000,0x1280000,0x2,0x3800000,0x106,0x2,0x2,0x6,0x6,0x6,0xfffffff6,0xfffffff2,0xfffffff6,0x2,0x2,0x2,0x2,0x6,0x106,0x106,0x106,0x106,0x700000,0x700000,0x6,0x6,0x6,0x6,0x106,0x106,0xf0000000,0x3ffffb6,0x3ffffb6,0x3ffffb6,0x10000000,0xc0000000,0x38ff9fe,0x38ff9fe,0x20000,0xa0010,0xa0010,0xf0000000,0x8,0x2,0x8,0xfb916,0x6,0x300a,0x2,0x6,0x3002,0x3002,0x2,0x2,0x20100,0x800,0x2006ab36,0x2006ab36,0x2006ad36,0x2006ad36,0x600,0xfb916,0xfb916,0x6,0x800,0x2010,0xf5080,0x600,0x6a616,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1f,0x1f,0x1f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x9,0x16,0x14,0x16,0x8,0x1,0x10,0x10,0x0,0x10,0x10,0x9,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x12,0x12,0x12,0x12,0x0,0x10,0x10,0x0,0x0,0x10,0x0,0x0,0x10,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[36];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public Parser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public Parser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 83; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 83; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 83; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 83; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 83; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 83; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = jj_lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[39];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 83; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 39; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 36; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
